; Notoof
;
; K Orton 2009

; PIC constants
W	EQU	0
F	EQU	1
STATUS	EQU	H'0003'
PORTB	EQU	H'0006'
PORTC	EQU	H'0007'
PIR1	EQU	H'000C'
TMR2	EQU	H'0011'
T2CON	EQU	H'0012'
CCPR1L	EQU	H'0015'
CCP1CN	EQU	H'0017'
ADRESH	EQU	H'001E'
ADCON0	EQU	H'001F'
OPTREG	EQU	H'0081'
TRISC	EQU	H'0087'
PR2	EQU	H'0092'
ADRESL	EQU	H'009E'
ADCON1	EQU	H'009F'
TMR2IF	EQU	1
GO	EQU	2
C	EQU	0
Z	EQU	2
RP0	EQU	5
RP1	EQU	6
CFG	EQU	H'3D31'

	__CONFIG	CFG

; Program constants
TMP1	EQU	H'0020'
TMP2	EQU	H'0021'
TMP3	EQU	H'0022'
TMP4	EQU	H'0023'
TMP5	EQU	H'0024'
CSUM	EQU	H'0025'

; Reset
	ORG	0
	MOVLW	1
	MOVWF	PORTC
	MOVLW	B'01000000'
	MOVWF	ADCON0
	BSF	STATUS,RP0
	BCF	OPTREG,7
	CLRF	TRISC
	MOVLW	D'208'
	MOVWF	PR2
	BSF	ADCON1,7
	BCF	STATUS,RP0
	MOVLW	D'104'
	MOVWF	CCPR1L
	MOVLW	B'00000001'
	MOVWF	T2CON
	CLRF	TMR2
	BCF	PIR1,TMR2IF
	BSF	T2CON,2
	MOVLW	B'00001100'
	MOVWF	CCP1CN
	BSF	ADCON0,0
L1	BTFSS	PIR1,TMR2IF
	GOTO	L1
	GOTO	LOOP

; Set output to zero state
SOP0	MOVLW	D'52'
	MOVWF	CCPR1L
	BCF	PIR1,TMR2IF
L2	BTFSS	PIR1,TMR2IF
	GOTO	L2
	BCF	PORTC,0
	BSF	STATUS,RP0
	MOVLW	D'104'
	MOVWF	PR2
	BCF	STATUS,RP0
	BCF	PIR1,TMR2IF
L3	BTFSS	PIR1,TMR2IF
	GOTO	L3
	RETURN

; Set output to one state
SOP1	MOVLW	D'104'
	MOVWF	CCPR1L
	BCF	PIR1,TMR2IF
L4	BTFSS	PIR1,TMR2IF
	GOTO	L4
	BSF	PORTC,0
	BSF	STATUS,RP0
	MOVLW	D'208'
	MOVWF	PR2
	BCF	STATUS,RP0
	RETURN

; Send hex pair to air
; Byte expected in W
SHEXA	MOVWF	TMP3
	ADDWF	CSUM
	SWAPF	TMP3,W
	CALL	L5
	MOVF	TMP3,W
L5	ANDLW	H'0F'
	ADDLW	H'F6'
	BTFSC	STATUS,C
	ADDLW	7
	ADDLW	H'3A'
; Drop through to...

; Send byte to air
; Byte expected in W
SBYTA	MOVWF	TMP1
	CALL	SOP0
	MOVLW	8
	MOVWF	TMP2
L6	BTFSS	TMP1,0
	GOTO	L7
	CALL	SOP1
	GOTO	L8
L7	CALL	SOP0
L8	RRF	TMP1
	DECFSZ	TMP2
	GOTO	L6
	CALL	SOP1
	RETURN

; Send space to air
; Space bit count expected in W
SSPCA	MOVWF	TMP1
L9	CALL	SOP1
	DECFSZ	TMP1
	GOTO	L9
	RETURN

; Send ADC sample to air
; Next mux setting (ADCON0) expected in W
SADCA	MOVWF	TMP4
	BSF	STATUS,RP0
	MOVF	ADRESL,W
	BCF	STATUS,RP0
	MOVWF	TMP5
	MOVF	ADRESH,W
	BSF	ADCON0,GO
	CALL	SHEXA
	MOVF	TMP4,W
	MOVWF	ADCON0
	MOVF	TMP5,W
	CALL	SHEXA
	RETURN

; Main loop
LOOP	CLRF	CSUM
	MOVLW	B'01010001'
	CALL	SADCA
	MOVLW	B'01011001'
	CALL	SADCA
	MOVLW	B'01100001'
	CALL	SADCA
	MOVLW	B'01000001'
	CALL	SADCA
	MOVLW	B'01001001'
	CALL	SADCA
	MOVF	PORTB,W
	CALL	SHEXA
	COMF	CSUM
	INCF	CSUM,W
	CALL	SHEXA
	MOVLW	D'13'
	CALL	SBYTA
	MOVLW	D'50'
	CALL	SSPCA
	GOTO	LOOP

	END
