Attribute VB_Name = "Module1"
    Declare Function mciSendString Lib "winmm.dll" Alias _
        "mciSendStringA" (ByVal lpstrCommand As String, ByVal _
        lpstrReturnString As Long, ByVal uReturnLength As Long, ByVal _
        hwndCallback As Long) As Long
    Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)
    Dim Samples() As Integer
    Dim Length As Long
    Dim Index As Long
    Dim Filter As Integer
    Const Hysteresis = 1000
    Dim Hex(24) As Byte
    Dim Binary(12) As Byte
    
    Public Function NotoofCapture(An0 As Integer, An1 As Integer, An2 As Integer, _
                           An3 As Integer, An4 As Integer, Digitals As Byte) As Boolean
        Dim Try As Integer
        Dim rv As Long
        Dim Fnum As Integer
        Dim Okay As Boolean
        Dim Skip As Long
        Dim Count As Integer
        Dim Bit As Integer
        Dim C As Byte
        Dim B As Byte
        Dim Wait As Long
       
        Wait = 600
        For Try = 1 To 3 ' Three tries to get a reading
            
            ' Try to capture about 0.5 seconds of the recording source
            rv = mciSendString("open new type waveaudio alias capture", 0&, 0, 0)
            If rv <> 0 Then GoTo Again
            rv = mciSendString("set capture bitspersample 16", 0&, 0, 0)
            If rv <> 0 Then
                rv = mciSendString("close capture", 0&, 0, 0)
                GoTo Again
            End If
            rv = mciSendString("set capture samplespersec 44100", 0&, 0, 0)
            If rv <> 0 Then
                rv = mciSendString("close capture", 0&, 0, 0)
                GoTo Again
            End If
            rv = mciSendString("set capture channels 1", 0&, 0, 0)
            If rv <> 0 Then
                rv = mciSendString("close capture", 0&, 0, 0)
                GoTo Again
            End If
            rv = mciSendString("record capture", 0&, 0, 0)
            If rv <> 0 Then
                rv = mciSendString("close capture", 0&, 0, 0)
                GoTo Again
            End If
            Sleep (Wait)
            rv = mciSendString("stop capture", 0&, 0, 0)
            If rv <> 0 Then
                rv = mciSendString("close capture", 0&, 0, 0)
                GoTo Again
            End If
            rv = mciSendString("save capture notoofcapture.wav", 0&, 0, 0)
            If rv <> 0 Then
                rv = mciSendString("close capture", 0&, 0, 0)
                GoTo Again
            End If
            rv = mciSendString("close capture", 0&, 0, 0)
       
            ' Read in the wave file then delete it
            Length = FileLen("notoofcapture.wav") / 2
            Fnum = FreeFile
            ReDim Samples(1 To Length)
            Open "notoofcapture.wav" For Binary As #Fnum
            Get #Fnum, 1, Samples
            Close Fnum
            If Dir("notoofcapture.wav") <> "" Then
                Kill "notoofcapture.wav"
            End If
        
            ' Skip header
            If Length < 6 Then
                GoTo Again
            End If
            Index = 7
            Length = Length - 6
      
            ' Skip to data chunk
            Do
                If Length < 4 Then GoTo Again
                If Samples(Index) = 24932 And Samples(Index + 1) = 24948 Then   ' "data"
                    Okay = True
                Else
                    Skip = CLng(Samples(Index + 2))
                    If Skip < 0 Then
                        Skip = Skip + 65536
                    End If
                    rv = CLng(Samples(Index + 3))
                    If rv < 0 Then
                        rv = rv + 65536
                    End If
                    Skip = Skip / 2 + 32768 * rv
                    If Length < (Skip + 4) Then GoTo Again
                    Index = Index + 4 + Skip
                    Length = Length - 4 - Skip
                    Okay = False
                End If
            Loop Until Okay
            Index = Index + 4
            Length = Length - 4
            
            ' Check we have enough samples. If not, ask for more
            If Length < 22050 Then
                Wait = Wait + 100
                GoTo Again
            End If
            
            ' Initialise high pass filter
            Filter = Samples(Index)
            
            ' Find period of silence ('1's)
            Count = 0
            Do
                Bit = NextPulse()
                If Bit = -1 Then GoTo Again
                If Bit = 1 Then
                    Count = Count + 1
                Else
                    Count = 0
                End If
            Loop While Count < 20
            
            ' Grab 24 hex characters
            For Count = 1 To 24
                C = NextChar()
                If C = 0 Then GoTo Again
                Hex(Count) = C
            Next Count
            
            ' Convert hex to binary
            For Count = 1 To 12
                C = Hex(Count * 2 - 1)
                If (C >= 65) And (C <= 70) Then ' A..F
                    B = C - 55
                Else
                    If (C >= 48) And (C <= 57) Then ' 0..9
                        B = C - 48
                    Else
                        GoTo Again
                    End If
                End If
                C = Hex(Count * 2)
                If (C >= 65) And (C <= 70) Then
                    C = C - 55
                Else
                    If (C >= 48) And (C <= 57) Then
                        C = C - 48
                    Else
                        GoTo Again
                    End If
                End If
                Binary(Count) = 16 * B + C
            Next Count
            
            ' Check checksum
            Bit = 0
            For Count = 1 To 12
                Bit = Bit + CInt(Binary(Count))
            Next Count
            Bit = Bit - (Bit / 256) * 256
            If Bit <> 0 Then GoTo Again
            
            ' Check analogue samples in range
            If Binary(1) > 3 Then GoTo Again
            If Binary(3) > 3 Then GoTo Again
            If Binary(5) > 3 Then GoTo Again
            If Binary(7) > 3 Then GoTo Again
            If Binary(9) > 3 Then GoTo Again
            
            ' Deliver extracted values
            An0 = CInt(Binary(1)) * 256 + CInt(Binary(2))
            An1 = CInt(Binary(3)) * 256 + CInt(Binary(4))
            An2 = CInt(Binary(5)) * 256 + CInt(Binary(6))
            An3 = CInt(Binary(7)) * 256 + CInt(Binary(8))
            An4 = CInt(Binary(9)) * 256 + CInt(Binary(10))
            Digitals = Binary(11)
            NotoofCapture = True
            Exit Function
Again:
        Next Try
        NotoofCapture = False
    End Function
Private Function NextChar() As Byte
    Dim Bit As Integer
    Dim C As Byte
    Dim BitCount As Integer
    
    Do
        Bit = NextPulse()
        If Bit = -1 Then
            NextChar = 0
            Exit Function
        End If
    Loop While Bit = 1
    Bit = NextPulse()
    If Bit = -1 Then
        NextChar = 0
        Exit Function
    End If
    C = 0
    For BitCount = 1 To 8
        Bit = NextPulse()
        If Bit = -1 Then
            NextChar = 0
            Exit Function
        End If
        C = C / 2
        If Bit = 1 Then
            C = C + 128
        Else
            Bit = NextPulse()
            If Bit = -1 Then
                NextChar = 0
                Exit Function
            End If
        End If
    Next
    NextChar = C
End Function
Private Function NextPulse() As Integer
    Dim Sample As Integer
    Dim Width As Integer
    Dim Diff As Long
    
    Do
        If Length = 0 Then
            NextPulse = -1
            Exit Function
        End If
        Sample = Samples(Index)
        Index = Index + 1
        Length = Length - 1
        Diff = CLng(Sample) - CLng(Filter)
        If Diff > 32767 Then
            Diff = 32767
        End If
        If Diff < -32768 Then
            Diff = -32768
        End If
        Sample = CInt(Diff)
        Filter = Filter + Sample / 20
    Loop While Sample < Hysteresis
    Width = 0
    Do
        If Length = 0 Then
            NextPulse = -1
            Exit Function
        End If
        Sample = Samples(Index)
        Index = Index + 1
        Length = Length - 1
        Diff = CLng(Sample) - CLng(Filter)
        If Diff > 32767 Then
            Diff = 32767
        End If
        If Diff < -32768 Then
            Diff = -32768
        End If
        Sample = CInt(Diff)
        Filter = Filter + Sample / 20
        Width = Width + 1
    Loop While Sample > -Hysteresis
    If Width >= 14 Then
        NextPulse = 1
    Else
        NextPulse = 0
    End If
End Function
